# Price Oracle

A Price Oracle is a contract that returns the price for any given asset pair. Price is retrieved either directly from an oracle, calculated using common asset pairs, or uses external data to calculate price. Note: Prices are returned in preciseUnits (i.e. 18 decimals of precision).

## Select View Methods

### oracles()

`mapping(address => mapping(address => IOracle)) public oracles;`

Mapping between assetA / assetB and its associated oracle. Asset 1 -> asset 2 -> source oracle address.&#x20;

| Parameter Name | Type    | Description               |
| -------------- | ------- | ------------------------- |
| assetOne       | address | Asset one to get price of |
| assetTwo       | address | Asset two to get price of |

| Return Name   | Type    | Description    |
| ------------- | ------- | -------------- |
| oracleAddress | IOracle | Oracle address |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.indexcoop.com/index-coop-community-handbook/protocol/index-protocol/core-contracts/price-oracle.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
